/**
 * Tinyii idowsFileBrowser - a TinyMCE File Manager Plugin for Yii 1.x
 * @License: MIT License
 * @Plugin info: TinyMCE filemanager plugin to be used with Yii 1.x 
 * or as a standalone filemanager without TinyMCE Editor in Yii 1.x
 * @Author: Muhammad Omer Aslam<buttflattery@gmail.com>
 * @url: https://plugins.idowstech.com
 * @Version: 1.0
 */
tinymce.PluginManager.add('idowsfilemanager', function(editor, url) {

    function idowsFileBrowser() {
        editor.windowManager.open({
            title: 'IDOWS Tinyii File Manager.',
            file: '/filemanager/index',
            width: 800,
            height: 600,
            buttons: [{
                text: 'Close',
                onclick: 'close'
            }]
        });
    }

    //add button on the editor to open idowsfilemanager
    editor.addButton('idowsfilemanager', {
        icon: 'image',
        text: 'IDOWS Tinyii FileManager',
        onclick: idowsFileBrowser,
        tooltip: 'IDOWS Tinyii Filemanager'
    });
});